# -*- coding:Utf-8 -*-


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es


# ==================================================
# >> EXCEPTIONS
# ==================================================


class EntityError(Exception):
    pass
    
    
# ==================================================
# >> UTILITAIRES
# ==================================================


def getEntity(entity):
    index = getEntityIndex(entity)
    if not index:
        raise EntityError, 'Entity "%s" not found!' % entity
    return EntityManager(index)
getentity = getEntity


def getIndexList(entity = None):
    returnvalue = list()
    if not entity:
        returnvalue = es.createentityindexlist().keys()
    else:
        returnvalue = es.createentityindexlist(entity).keys()
        if not len(returnvalue):
            entities = es.createentityindexlist()
            for index in entities:
                if str(entity).lower() in entities[index]['classname']:
                    returnvalue.append(index)
    return returnvalue
getindexlist = getIndexList


def getEntityList(entity = None):
    returnvalue = list()
    for index in getIndexList(entity):
        if index:
            returnvalue.append(EntityManager(index))
    return returnvalue
getentitylist = getEntityList


def exists(entity):
    return bool(getEntityIndex(entity))
    
    
def getEntityIndex(entity):
    returnvalue = None
    if str(entity).isdigit() and bool(es.getindexprop(entity, 'CBaseEntity.m_hOwnerEntity')):
        returnvalue = int(entity)
    else:
        for index in es.createentityindexlist():
            if str(entity).lower() == es.entitygetvalue(index, 'targetname'):
                returnvalue = index
                break
    return returnvalue
getentityindex = getEntityIndex


# ==================================================
# >> CLASSES
# ==================================================


class EntityManager(object):
    def __init__(self, index):
        self.index = index
        self.props = es.createentitylist(index)[index]
        
        
    def __getitem__(self, item):
        returnvalue = es.getindexprop(self.index, item)
        if not returnvalue:
            for prop in self.props:
                if item.lower() in prop.lower():
                    returnvalue = es.getindexprop(self.index, prop)
                    break
        return returnvalue
        
        
    def __setitem__(self, item, value):
        if es.getindexprop(self.index, item) is not None:
            es.setindexprop(self.index, item, value)
        else:
            for prop in self.props:
                if item.lower() in prop.lower():
                    es.setindexprop(self.index, prop, value)
                    break
                    
                    
    def __getattr__(self, attribute):
        returnvalue = None
        if attribute in self.__dict__:
            returnvalue = object.__getattr__(self, attribute)
        else:
            value = es.entitygetvalue(self.index, attribute)
            if value:
                returnvalue = value
        return returnvalue
        
        
    def __setattr__(self, attribute, value):
        if attribute in ['index', 'props']:
            object.__setattr__(self, attribute, value)
        else:
            es.entitysetvalue(self.index, attribute, value)
