# -*- coding:Utf-8 -*-
from simplemenu_line import SimpleLine
import psyco, langlib, simplemenu_tool
psyco.full()

def i_checkSep(separator):
    lines = []
    if isinstance(separator, str): lines = [line for line in separator.split("\n") if line]
    else:
        try:
            for line in separator:
                lines += [line for line in str(line).split("\n") if line]
        except TypeError: pass
    return lines

class SimpleBase(SimpleLine):
    def __init__(self, reversenav, defaultlang, separators):
        self["separators"] = separators
        self["defaultlang"] = defaultlang
        self.b_reversenav = bool(reversenav)
        #self.b_timeout = [0, "view"]


    def __setitem__(self, item, value):
        if item == "defaultlang":
            lang = "en"
            value = str(value)
            languages = langlib.getLanguages()

            for language in languages:
                if value == language:
                    lang = languages[language]["id"]
                    break

                else:
                    langid = languages[language]["id"]
                    if value == langid:
                        lang = value
                        break
            self.b_defaultlang = lang

        elif item == "separators":
            self.b_startchoice = 0
            self.b_startnavigation = 0
            self.b_separators = [[], [], [], []]

            try:
                sep1 = self.b_separators[0] = simplemenu_tool.getSepList(value[0])
                self.b_startchoice += len(sep1)

                sep2 = self.b_separators[1] = simplemenu_tool.getSepList(value[1])
                self.b_startchoice += len(sep2)

                self.b_startnavigation += self.b_startchoice
                sep3 = self.b_separators[2] = simplemenu_tool.getSepList(value[2])
                self.b_startnavigation += len(sep2)
                sep4 = self.b_separators[3] = simplemenu_tool.getSepList(value[3])
            except IndexError: pass
