# -*- coding:Utf-8 -*-
import es, psyco, playerlib
psyco.full()

def getTitle(title, options = {}):
    for option in options:
        title = string.replace(option, options[option])
    return title

def getSepList(separator):
    lines = []
    if isinstance(separator, str): lines = getSplitString(separator)
    else:
        try:
            for line in separator: lines += getSplitString(str(line))
        except TypeError: pass
    return lines

def getSplitString(string):
    return [line for line in str(string).split("\n") if line]

def getTotalPage(items):
    if items < 2: total = 1
    else:
        total = items / 7
        if items % 7 > 1: total += 1
    return total

def getItemsPage(current, pages, total):
    if current < pages: items = 7
    else: items = total - (current - 1) * 7
    return items

def getUsers(users):
    useridlist = []
    if isinstance(users, str):
        if users.startswith("#"):
            useridlist = playerlib.getUseridList(users)
        else: useridlist = [es.getuserid(users)]
    elif isinstance(users, int): useridlist = [es.getuserid(users)]

    else:
        try:
            for user in users:
                userid = es.getuserid(user)
                if not userid in useridlist: useridlist.append(userid)
        except TypeError: pass
    return [userid for userid in useridlist if es.exists("userid", userid) and not es.isbot(userid)]
