# -*- coding:Utf-8 -*-
from popuplib2 import _usermanager
from simplemenu_line import SimpleLine
import es, psyco, langlib, simplemenu_tool
psyco.full()

class SimpleBase(SimpleLine):
    def __init__(self, reversenav, defaultlang, separators):
        self.b_starttitle = -1
        self.b_startoptions = -1
        self.b_startnavigation = -1
        self.b_separators = [[], [], [], []]

        self.b_select = None
        self.b_selectic = None
        self.b_selectnc = None
        self.b_returnkey = False

        self.b_showback = True
        self.b_shownext = True
        self.b_showquit = True
        self.b_showtitle = False
        self.b_showpage = "auto"

        self.p_multilang = False
        self.b_menulang = {
            "_smlib_page" : {"en" : "      ($page/$total)", "fr" : "      ($page/$total)"},
            "_smlib_next" : {"en" : "Next page", "fr" : "Page suivante"},
            "_smlib_back" : {"en" : "Previous page", "fr" : "Page précédente"},
            "_smlib_exit" : {"en" : "Cancel", "fr" : "Fermer le menu"}}

        self.b_reversenav = bool(reversenav)
        self["defaultlang"] = defaultlang
        self["separators"] = separators

    def __setitem__(self, item, value):
        if item == "defaultlang":
            lang = "en"
            value = str(value)
            languages = langlib.getLanguages()

            for language in languages:
                if value == language:
                    lang = languages[language]["id"]
                    break

                else:
                    langid = languages[language]["id"]
                    if value == langid:
                        lang = value
                        break
            self.b_defaultlang = lang

        elif item == "separators":
            self.b_starttitle = -1
            self.b_startoptions = -1
            self.b_startnavigation = -1
            self.b_separators = [[], [], [], []]

            try:
                sep0 = self.b_separators[0] = simplemenu_tool.getSepList(value[0])
                self.b_starttitle += len(sep0)
                sep1 = self.b_separators[1] = simplemenu_tool.getSepList(value[1])
                self.b_startoptions = self.b_starttitle + len(sep1)
                sep2 = self.b_separators[2] = simplemenu_tool.getSepList(value[2])
                self.b_startnavigation = self.b_startoptions + len(sep2)
                sep3 = self.b_separators[3] = simplemenu_tool.getSepList(value[3])
            except IndexError: pass

        elif item == "returnkey":
            value = bool(value)
            if not self.p_constructed: self.b_returnkey = value
            else:
                self.b_returnkey = value

                popup = self.p_pages[0]
                navfunc = popup.menuselect_args["navfunc"]
                keyindex = 7 if len(self.p_pages) > 1 else len(self.p_lines) - 1
                index = self.b_startnavigation + keyindex
                if self.b_showtitle: index += 1

                if self.b_reversenav: returnkey, index = 9, index + 1
                else: returnkey = 8
                if self.b_returnkey:
                    if navfunc.has_key(returnkey):
                        del navfunc[returnkey]
                        del popup[index]

                else:
                    if not navfunc.has_key(returnkey):
                        popup.insert(index, "%s. %s" % (returnkey, self.b_menulang["_smlib_back"][self.b_defaultlang]))
                        navfunc[returnkey] = 0

        elif item == "select":
            self.b_select = value
            if not callable(value): es.dbgmsg(1, 'simplemenulib: select function "%s" is currently not callable' % value)
        elif item == "selectic":
            self.b_selectic = value
            if not callable(value): es.dbgmsg(1, 'simplemenulib: selectic function "%s" is currently not callable' % value)
        elif item == "selectnc":
            self.b_selectnc = value
            if not callable(value): es.dbgmsg(1, 'simplemenulib: selectnv function "%s" is currently not callable' % value)

    def i_indexList(self, item, value):
        for indexlist in xrange(1, len(self.p_lines)):
            line = self.p_lines[indexlist]
            if item == line.l_item:
                if not value: return indexlist
                elif value == line.l_value: return indexlist
        return False

    def i_title(self):
        title = self.p_lines[0]
        totalpage = len(self.p_pages)
        if isinstance(title, SimpleLine): title = title["modifieditem"]
        if not title:
            if self.b_showtitle:
                for currentpage in xrange(0, totalpage):
                    del self.p_pages[currentpage][self.b_starttitle + 1]
            self.b_showtitle = False

        else:
            if self.b_showpage == "auto": showpage = True if totalpage > 1 else False
            else: showpage = bool(self.b_showpage)
            if showpage: title += self.b_menulang["_smlib_page"][self.b_defaultlang]

            if self.b_showtitle:
                for currentpage in xrange(1, totalpage + 1):
                    self.p_pages[currentpage - 1][self.b_starttitle + 1] = title.replace("$page", str(currentpage)).replace("$total", str(totalpage))
            else:
                for currentpage in xrange(1, totalpage + 1):
                    self.p_pages[currentpage - 1].insert(self.b_starttitle + 1, title.replace("$page", str(currentpage)).replace("$total", str(totalpage)))
            self.b_showtitle = True

    def i_moditem(self, indexlist, line, newitem):
        item, value, options, prefix, underline = newitem
        page, index, listid, popup = line.l_page, line.l_index, line.l_listid, line.l_popup
        line = self.p_lines[indexlist] = SimpleLine(item, value, options, prefix, underline, page, index, listid, popup)
        if self.p_constructed:
            if self.b_showtitle: index += 1
            popup[self.b_startoptions + index] = line["formatline"]
            popup.menuselect_args["values"][index] = line

    def setitem(self, item, value = "", options = {}, prefix = "", underline = True, withvalue = ""):
        item, underline = str(item), bool(underline)
        indexlist = self.i_indexList(item, withvalue)
        if indexlist is False: es.dbgmsg(1, 'simplemenulib: cannot find item "%s" for menu "%s"' % (item, value))
        else: self.i_moditem(indexlist, self.p_lines[indexlist], (item, value, options, prefix, underline))

    def moditem(self, item, newitem, value = "", options = {}, prefix = "", underline = True, withvalue = ""):
        item, newitem, underline = str(item), str(newitem), bool(underline)
        indexlist = self.i_indexList(item, withvalue)
        if indexlist is False: es.dbgmsg(1, 'simplemenulib: cannot find item "%s" for menu "%s"' % (item, value))
        else: self.i_moditem(indexlist, self.p_lines[indexlist], (newitem, value, options, prefix, underline))

    def pagecount(self):
        return simplemenu_tool.getTotalPage(self.itemcount())

    def itemcount(self):
        return len(self.p_lines)
