# -*- coding:Utf-8 -*-
from simplemenu_line import SimpleLine
from simplemenu_base import SimpleBase
import psyco, es, sys, popuplib2, simplemenu_tool
psyco.full()

class SimpleMenu(SimpleBase, SimpleLine):
    def __init__(self, name, defaultlang, separators, reversenav):
        self.name = name
        self.type = "menu"
        self.p_pages = []
        self.p_constructed = False
        self.p_lines = [SimpleLine("", page = 1, index = 0, listid = 0)]
        SimpleBase.__init__(self, reversenav, defaultlang, separators)

    def __del__(self):
        for popup in self.p_pages: del popup

    def i_select(self, args):
        userid, index, page = args["userid"], args["choice"], args["page"]
        values, navfunc = args["values"], args["navfunc"]

        callfunc, submenu = False, False
        if values.has_key(index):
            line = values[index]
            userargs = {"userid" : userid, "choice" : index, "item" : line.l_item, "value" : line.l_value, "popup" : self,
                        "popupid" : self.name, "page" : page, "modifieditem" : line["modifieditem"]}
            if self.b_select is None: es.dbgmsg(1, "simplemenulib: select function is not defined")
            else: callfunc = self.b_select

        elif navfunc.has_key(index):
            userargs = {"userid" : userid, "choice" : index, "popup" : self, "popupid" : self.name, "page" : page}
            if self.b_selectnc is None: es.dbgmsg(1, "simplemenulib: selectnc function is not defined")
            else: callfunc = self.b_selectnc
            newpage = navfunc[index]
            if newpage:
                try: submenu = self.p_pages[page + newpage - 1]
                except IndexError: pass

        else:
            userargs = {"userid" : userid, "choice" : index, "popup" : self, "popupid" : self.name, "page" : page}
            if self.b_selectic is None: es.dbgmsg(1, "simplemenulib: selectic function is not defined")
            else: callfunc = self.b_selectic

        if callfunc:
            try: callfunc(userargs)
            except Exception:
                sys.excepthook(*sys.exc_info())
                sys.exc_clear()
        if submenu: submenu.send(userid)

    def construct(self):
        indexlist = 1
        totalitem = len(self.p_lines) - 1
        totalpage = simplemenu_tool.getTotalPage(totalitem)
        if len(self.p_pages) > totalpage:
            for popup in self.p_pages[totalpage:]: del popup

        for currentpage in xrange(1, totalpage + 1):
            popup = popuplib2.Popup()
            self.p_pages.append(popup)
            value = popup.menuselect_args["value"] = {}
            navfunc = popup.menuselect_args["navfunc"] = {}

            for sep in self.b_separators[0]: popup.append(sep)
            if currentpage == 1: self.p_lines[0].l_popup = popup
            for sep in self.b_separators[1]: popup.append(sep)

            for indexitem in xrange(1, simplemenu_tool.getItemsPage(currentpage, totalpage, totalitem) + 1):
                line = self.p_lines[indexlist]
                line.l_page = currentpage
                line.l_index = indexitem
                line.l_listid = indexlist
                line.l_popup = popup
                line.l_modifieditem = None
                popup.append(line["formatline"])
                value[indexitem] = line
                indexlist += 1

            for sep in self.b_separators[2]: popup.append(sep)
            cmppage = cmp(totalpage, currentpage)

            if self.b_reversenav:
                if cmppage:
                    navfunc[8] = 1
                    popup.append("8. " + self.b_menulang["_smlib_next"][self.b_defaultlang])
                if currentpage == 1:
                    if self.b_returnkey:
                        navfunc[9] = 0
                        popup.append("9. " + self.b_menulang["_smlib_back"][self.b_defaultlang])
                else:
                    navfunc[9] = -1
                    popup.append("9. " + self.b_menulang["_smlib_back"][self.b_defaultlang])

            else:
                if currentpage == 1:
                    if self.b_returnkey:
                        navfunc[8] = 0
                        popup.append("8. " + self.b_menulang["_smlib_back"][self.b_defaultlang])
                elif cmppage > -1:
                    navfunc[8] = - 1
                    popup.append("8. " + self.b_menulang["_smlib_back"][self.b_defaultlang])
                if cmppage:
                    navfunc[9] = 1
                    popup.append("9. " + self.b_menulang["_smlib_next"][self.b_defaultlang])

            navfunc[10] = 0
            popup.append("0. " + self.b_menulang["_smlib_exit"][self.b_defaultlang])
            popup.menuselect_args = {"page" : currentpage, "values" : value, "navfunc" : navfunc}
            popup.menuselect = self.i_select
            for sep in self.b_separators[3]: popup.append(sep)
        self.i_title()
        self.p_constructed = True

    def title(self, title, options = {}, showpage = "auto"):
        title = str(title)
        self.b_showpage = bool(showpage) if showpage <> "auto" else showpage
        if title:
            titleline = self.p_lines[0]
            titleline.l_item = title
            titleline.l_options = options
        if self.p_constructed: self.i_title()

    def additem(self, item, value = "", options = {}, prefix = "", underline = True):
        item, underline = str(item), bool(underline)
        if not self.p_constructed: self.p_lines.append(SimpleLine(item, value, options, prefix, underline))
        else:
            lastline = self.p_lines[-1]
            newline = SimpleLine(item, value, options, prefix, underline)
            if not lastline.l_listid: newline.l_popup = self.p_pages[0]
            self.p_lines.append(newline)

            if lastline.l_index < 8:
                newline.l_page = lastline.l_page
                newline.l_index = lastline.l_index + 1
                newline.l_listid = lastline.l_listid + 1
                newline.l_popup = lastline.l_popup

                index = self.b_startoptions + newline.l_index
                if self.b_showtitle: index += 1
                popup = newline.l_popup
                popup.insert(index, newline["formatline"])
                popup.menuselect_args["values"][newline.l_index] = newline

            else:
                if self.b_reversenav: keyback, keynext, delete, index = 9, 8, self.b_startoptions + lastline.l_index, self.b_startnavigation + lastline.l_index
                else: keyback, keynext, delete, index = 8, 9, self.b_startoptions + lastline.l_index, self.b_startnavigation + lastline.l_index
                if self.b_showtitle: delete, index = delete + 1, index + 1

                popup = lastline.l_popup
                del popup.menuselect_args["values"][lastline.l_index]
                del popup[delete]
                popup.insert(index, "%s. %s" % (keynext, self.b_menulang["_smlib_next"][self.b_defaultlang]))
                popup.menuselect_args["navfunc"][keynext] = 1

                popup = popuplib2.Popup()
                self.p_pages.append(popup)
                lastline.l_page = lastline.l_page + 1
                lastline.l_index = 1
                lastline.l_popup = popup
                lastline.l_modifieditem = None

                newline.l_page = lastline.l_page
                newline.l_index = lastline.l_index + 1
                newline.l_listid = lastline.l_listid + 1
                newline.l_popup = popup

                popup.menuselect_args["page"] = newline.l_page
                popup.menuselect_args["navfunc"] = {keyback : -1, 10 : 0}
                popup.menuselect_args["values"] = {1 : lastline, 2 : newline}
                for sep in self.b_separators[0]: popup.append(sep)
                if self.b_showtitle: popup.append(self.p_lines[0]["formatline"])
                for sep in self.b_separators[1]: popup.append(sep)
                popup.append(lastline["formatline"])
                popup.append(newline["formatline"])

                for sep in self.b_separators[2]: popup.append(sep)
                popup.append("%s. %s" % (keyback, self.b_menulang["_smlib_back"][self.b_defaultlang]))
                popup.append("0. " + self.b_menulang["_smlib_exit"][self.b_defaultlang])
                for sep in self.b_separators[3]: popup.append(sep)
                popup.menuselect = self.i_select
                self.i_title()

    def delitem(self, item, withvalue = "", pageindex = ()):
        item = str(item)
        indexlist = self.i_indexList(item, withvalue, pageindex)
        if indexlist < 0: es.dbgmsg(1, 'simplemenulib: cannot find item "%s" for menu "%s"' % (item, self.name))
        else:
            pass
            #self.i_moditem(indexlist, self.p_lines[indexlist], (item, value, options, prefix, underline), update)

    def send(self, users, page = 1):
        useridlist = simplemenu_tool.getUsers(users)
        if not useridlist: es.dbgmsb(1, 'simplemenulib: wrong value for parameter "users"')
        else:
            if not self.p_constructed: self.construct()
            try: page = int(page)
            except ValueError:
                es.dbgmsb(1, 'simplemenulib: wrong value for parameter "page"')
                page = 1

            try:
                popup = self.p_pages[page - 1]
                for userid in useridlist: popup.send(userid)
            except IndexError:
                es.dbgmsb(1, 'simplemenulib: cannot send page "%s" of menu "%s"' % (page, self.name))
                try: 
                    popup = self.p_pages[0]
                    for userid in useridlist: popup.send(userid)
                except IndexError: es.dbgmsb(0, 'simplemenulib: cannot send menu "%s"' % self.name)
